<template>
  <div class="bill-table">
    <div class="flex items-center justify-between py-2 px-4">
      <div class="text-2xl text-primary font-semibold">รายการค่าไฟฟ้า</div>

      <div class="flex items-center gap-4">
        <img
          :src="require('~/assets/images/Export Pdf.svg')"
          alt="Export Pdf.svg"
          class="cursor-pointer"
        />

        <img
          :src="require('~/assets/images/Xls Export.svg')"
          alt="Xls Export.svg"
          class="cursor-pointer"
        />

        <img
          :src="require('~/assets/images/Export CSV.svg')"
          alt="Export CSV.svg"
          class="cursor-pointer"
        />
      </div>
    </div>

    <div class="overflow-auto" style="height: calc(100% - 48px)">
      <div
        class="bg-blue rounded-md sticky top-0 flex justify-between font-semibold"
      >
        <div
          v-for="(th, th_index) in table_heads"
          :key="th_index"
          :class="th.class"
          class="p-2"
        >
          {{ th.name }}
        </div>
      </div>

      <div v-for="(ti, ti_index) in table_items" :key="ti_index">
        <div class="flex justify-between">
          <div
            v-for="(th, th_index) in table_heads"
            :key="th_index"
            :class="th.class"
            class="py-3"
          >
            <div
              v-if="['price_diff', 'unit_diff'].includes(th.key)"
              :class="{
                'flex items-center justify-center': true,
                'text-green': ti[th.key].status === 'down',
                'text-red': ti[th.key].status === 'up',
              }"
            >
              <img
                v-if="ti[th.key].status === 'down'"
                :src="require('~/assets/images/down.svg')"
                alt="down.svg"
                class="mr-[2px]"
              />

              <img
                v-if="ti[th.key].status === 'up'"
                :src="require('~/assets/images/up.svg')"
                alt="up.svg"
                class="mr-[2px]"
              />

              {{ numeral(ti[th.key].value).format("0,0") }}

              <img
                v-if="th_index === table_heads.length - 1"
                :src="require('~/assets/images/Play.svg')"
                alt="Play.svg"
                :class="{
                  'ml-4 cursor-pointer': true,
                  'transform rotate-180': selected_table_item.id === ti.id,
                }"
                @click="selectTableItem(ti)"
              />
            </div>

            <template v-else-if="['unit', 'price'].includes(th.key)">
              {{ numeral(ti[th.key]).format("0,0") }}
            </template>

            <template v-else>
              {{ ti[th.key] }}
            </template>
          </div>
        </div>

        <div
          v-if="
            selected_table_item.id === ti.id && selected_table_item.meter_detail
          "
          class="px-6"
        >
          <div class="flex justify-between text-primary">
            <div
              v-for="(th, th_index) in selected_table_item.meter_detail
                .table_heads"
              :key="th_index"
              :class="th.class"
            >
              {{ th.name }}
            </div>
          </div>

          <div
            v-for="(ti, ti_index) in selected_table_item.meter_detail
              .table_items"
            :key="ti_index"
          >
            <div
              class="flex justify-between cursor-pointer"
              @click="selectMeter(ti)"
            >
              <div
                v-for="(th, th_index) in selected_table_item.meter_detail
                  .table_heads"
                :key="th_index"
                :class="th.class"
                class="py-2 text-white"
              >
                <template v-if="th.key === 'position'">{{
                  ti[th.key].name
                }}</template>

                <template v-else>
                  {{ ti[th.key] }}
                </template>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import numeral from "numeral";

export default {
  props: {
    table_items: {
      type: Array,
      default: () => {
        return [];
      },
    },
    selected_table_item: {
      type: Object,
      default: () => {
        return {};
      },
    },
    selectTableItem: {
      type: Function,
      default: () => {
        return {};
      },
    },
    selectMeter: {
      type: Function,
      default: () => {
        return {};
      },
    },
  },
  data() {
    return {
      numeral: numeral,
      table_heads: [
        {
          name: "ปี",
          key: "year",
          class: "text-center w-[90px]",
        },
        {
          name: "เดือน",
          key: "month",
          class: "text-center w-[90px]",
        },
        {
          name: "จำนวนหน่วย (kWh)",
          key: "unit",
          class: "text-center w-[200px]",
        },
        {
          name: "ส่วนต่างต่อหน่วย",
          key: "unit_diff",
          class: "text-center w-[150px]",
        },
        {
          name: "ค่าไฟฟ้า (บาท)",
          key: "price",
          class: "text-center w-[130px]",
        },
        {
          name: "ส่วนต่างค่าไฟฟ้า",
          key: "price_diff",
          class: "text-center w-[150px]",
        },
      ],
    };
  },
};
</script>

<style lang="scss" scoped></style>
